unit SafeUpAndDown.FormUpAndDown;

interface

uses
  Winapi.Windows, Winapi.Messages,
  System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ComCtrls, Vcl.ExtCtrls;

type
  TFrmUpAndDown = class(TForm)
    edLoops: TEdit;
    Label1: TLabel;
    btnStartThreads: TButton;
    lbOutput: TListBox;
    tmrDisplay: TTimer;
    Button1: TButton;
    Label2: TLabel;
    lblGlobalCounter: TLabel;
    btnClearListbox: TButton;
    btnNoThread: TButton;
    cbSynced: TCheckBox;
    procedure btnStartThreadsClick(Sender: TObject);
    procedure tmrDisplayTimer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure btnClearListboxClick(Sender: TObject);
    procedure btnNoThreadClick(Sender: TObject);
  private
  public
  end;

var
  FrmUpAndDown: TFrmUpAndDown;

implementation

uses
  System.Diagnostics, SafeUpAndDown.UpAndDownThread;

{$R *.DFM}


procedure TFrmUpAndDown.btnStartThreadsClick(Sender: TObject);
var
  LLoopCount: NativeInt;
begin
  LLoopCount := StrToInt(edLoops.Text);
  TUpAndDownThread.Create(LLoopCount, true, cbSynced.Checked, lbOutput.Items);
  TUpAndDownThread.Create(LLoopCount, false,cbSynced.Checked, lbOutput.Items);
end;

procedure TFrmUpAndDown.tmrDisplayTimer(Sender: TObject);
begin
  lblGlobalCounter.Caption := IntToStr(GlobalCounter);
end;

procedure TFrmUpAndDown.Button1Click(Sender: TObject);
begin
  GlobalCounter := 0;
end;

procedure TFrmUpAndDown.btnClearListboxClick(Sender: TObject);
begin
  lbOutput.Clear;
end;

procedure TFrmUpAndDown.btnNoThreadClick(Sender: TObject);
var
  LIndex,LLoopCount: Integer;
  LStopWatch: TStopwatch;
begin
  LLoopCount := StrToInt(edLoops.Text);
  lbOutput.Items.Add('seriell, kein Thread gestartet');
  LStopWatch := TStopwatch.StartNew;
  for LIndex := 1 to LLoopCount do
  begin
    Inc(GlobalCounter);
  end;
  for LIndex := 1 to LLoopCount do
  begin
    Dec(GlobalCounter);
  end;
  LStopwatch.Stop;

  lbOutput.Items.Add(Format('seriell, kein Thread fertig nach %d Millisekunden',
                     [LStopWatch.ElapsedMilliseconds]));
end;

end.
