unit SyncCriticalSectionAPI.FormUpAndDown;

interface

uses
  Winapi.Windows, Winapi.Messages,
  System.SysUtils, System.Variants, System.Classes, System.SyncObjs,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ComCtrls, Vcl.ExtCtrls;

type
  TFrmUpAndDown = class(TForm)
    edLoops: TEdit;
    Label1: TLabel;
    btnStartThreads: TButton;
    lbOutput: TListBox;
    tmrDisplay: TTimer;
    Button1: TButton;
    Label2: TLabel;
    lblGlobalCounter: TLabel;
    btnClearListbox: TButton;
    procedure btnStartThreadsClick(Sender: TObject);
    procedure tmrDisplayTimer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure btnClearListboxClick(Sender: TObject);
  private
    FCriticalSection: TRTLCriticalSection;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

  end;

var
  FrmUpAndDown: TFrmUpAndDown;

implementation

uses
  SyncCriticalSectionAPI.UpAndDownThread;

{$R *.DFM}


procedure TFrmUpAndDown.btnStartThreadsClick(Sender: TObject);
var
  LLoopCount: NativeInt;
begin
  LLoopCount := StrToInt(edLoops.Text);
  TUpAndDownThread.Create(LLoopCount, true,  @FCriticalSection, lbOutput.Items);
  TUpAndDownThread.Create(LLoopCount, false, @FCriticalSection, lbOutput.Items);
end;

procedure TFrmUpAndDown.tmrDisplayTimer(Sender: TObject);
begin
  if TryEnterCriticalSection(FCriticalSection) then
  begin
    try
      lblGlobalCounter.Caption := IntToStr(GlobalCounter);
    finally
      LeaveCriticalSection(FCriticalSection);
    end;
  end;
end;

procedure TFrmUpAndDown.Button1Click(Sender: TObject);
begin
  GlobalCounter := 0;
end;

constructor TFrmUpAndDown.Create(AOwner: TComponent);
begin
  inherited;
  InitializeCriticalSection(FCriticalSection);
end;

destructor TFrmUpAndDown.Destroy;
begin
  DeleteCriticalSection(FCriticalSection);
  inherited;
end;

procedure TFrmUpAndDown.btnClearListboxClick(Sender: TObject);
begin
  lbOutput.Clear;
end;


end.
