unit SyncMonitor.FormUpAndDown;

interface

uses
  Winapi.Windows, Winapi.Messages,
  System.SysUtils, System.Variants, System.Classes, System.SyncObjs,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ComCtrls, Vcl.ExtCtrls;

type
  TFrmUpAndDown = class(TForm)
    edLoops: TEdit;
    Label1: TLabel;
    btnStartThreads: TButton;
    lbOutput: TListBox;
    tmrDisplay: TTimer;
    Button1: TButton;
    Label2: TLabel;
    lblGlobalCounter: TLabel;
    btnClearListbox: TButton;
    procedure btnStartThreadsClick(Sender: TObject);
    procedure tmrDisplayTimer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure btnClearListboxClick(Sender: TObject);
  end;

var
  FrmUpAndDown: TFrmUpAndDown;

implementation

uses
  SyncMonitor.UpAndDownThread;

{$R *.DFM}


procedure TFrmUpAndDown.btnStartThreadsClick(Sender: TObject);
var
  loopCount: NativeInt;
begin
  loopCount := StrToInt(edLoops.Text);
  TUpAndDownThread.Create(loopCount, true,  self, lbOutput.Items);
  TUpAndDownThread.Create(loopCount, false, self, lbOutput.Items);
end;

procedure TFrmUpAndDown.tmrDisplayTimer(Sender: TObject);
begin
  if System.TMonitor.TryEnter(self) then
  begin
    try
      lblGlobalCounter.Caption := IntToStr(GlobalCounter);
    finally
      System.TMonitor.Exit(self);
    end;
  end;
end;

procedure TFrmUpAndDown.Button1Click(Sender: TObject);
begin
  GlobalCounter := 0;
end;


procedure TFrmUpAndDown.btnClearListboxClick(Sender: TObject);
begin
  lbOutput.Clear;
end;


end.
