unit SyncSpinLock.FormUpAndDown;

interface

uses
  Winapi.Windows, Winapi.Messages,
  System.SysUtils, System.Variants, System.Classes, System.SyncObjs,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ComCtrls, Vcl.ExtCtrls;

type
  TFrmUpAndDown = class(TForm)
    edLoops: TEdit;
    Label1: TLabel;
    btnStartThreads: TButton;
    lbOutput: TListBox;
    tmrDisplay: TTimer;
    Button1: TButton;
    Label2: TLabel;
    lblGlobalCounter: TLabel;
    btnClearListbox: TButton;
    procedure btnStartThreadsClick(Sender: TObject);
    procedure tmrDisplayTimer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure btnClearListboxClick(Sender: TObject);
  private
    FSpinLock: TSpinLock;
  public
    constructor Create(AOwner: TComponent); override;

  end;

var
  FrmUpAndDown: TFrmUpAndDown;

implementation

uses
  SyncSpinLock.UpAndDownThread;

{$R *.DFM}


procedure TFrmUpAndDown.btnStartThreadsClick(Sender: TObject);
var
  LLoopCount: NativeInt;
begin
  LLoopCount := StrToInt(edLoops.Text);
  TUpAndDownThread.Create(LLoopCount, true,  @FSpinLock, lbOutput.Items);
  TUpAndDownThread.Create(LLoopCount, false, @FSpinLock, lbOutput.Items);
end;

procedure TFrmUpAndDown.tmrDisplayTimer(Sender: TObject);
begin
  if FSpinLock.TryEnter then
  try
    lblGlobalCounter.Caption := IntToStr(GlobalCounter);
  finally
    FSpinLock.Exit;
  end;
end;

procedure TFrmUpAndDown.Button1Click(Sender: TObject);
begin
  GlobalCounter := 0;
end;

constructor TFrmUpAndDown.Create(AOwner: TComponent);
begin
  inherited;
  FSpinLock := TSpinlock.Create(false);
end;


procedure TFrmUpAndDown.btnClearListboxClick(Sender: TObject);
begin
  lbOutput.Clear;
end;


end.
