unit SyncTemplate.PrjFormUpAndDown;

interface

uses
  Winapi.Windows, Winapi.Messages,
  System.SysUtils, System.Variants, System.Classes, System.SyncObjs,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ComCtrls, Vcl.ExtCtrls;

type
  TPrjFrmUpAndDown = class(TForm)
    edLoops: TEdit;
    Label1: TLabel;
    btnStartThreads: TButton;
    lbOutput: TListBox;
    tmrDisplay: TTimer;
    Button1: TButton;
    Label2: TLabel;
    lblGlobalCounter: TLabel;
    btnClearListbox: TButton;
    procedure btnStartThreadsClick(Sender: TObject);
    procedure tmrDisplayTimer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure btnClearListboxClick(Sender: TObject);
  private
    FCriticalSection: TCriticalSection;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

  end;

var
  PrjFrmUpAndDown: TPrjFrmUpAndDown;

implementation

uses
   SafeUpAndDown.PrjClassUpAndDown;

{$R *.DFM}


procedure TPrjFrmUpAndDown.btnStartThreadsClick(Sender: TObject);
var
  LLoopCount: NativeInt;
begin
  LLoopCount := StrToInt(edLoops.Text);
  TPrjClassUpAndDown.Create(LLoopCount, true,  FCriticalSection, lbOutput.Items);
  TPrjClassUpAndDown.Create(LLoopCount, false, FCriticalSection, lbOutput.Items);
end;

procedure TPrjFrmUpAndDown.tmrDisplayTimer(Sender: TObject);
begin
  FCriticalSection.Enter;
  lblGlobalCounter.Caption := IntToStr(GlobalCounter);
  FCriticalSection.Leave;
end;

procedure TPrjFrmUpAndDown.Button1Click(Sender: TObject);
begin
  GlobalCounter := 0;
end;

constructor TPrjFrmUpAndDown.Create(AOwner: TComponent);
begin
  inherited;
  FCriticalSection := TCriticalSection.Create;
end;

destructor TPrjFrmUpAndDown.Destroy;
begin
  FCriticalSection.Free;
  inherited;
end;

procedure TPrjFrmUpAndDown.btnClearListboxClick(Sender: TObject);
begin
  lbOutput.Clear;
end;


end.
