unit ZipperSample.SimpleZip;

interface

uses
  System.Classes;

type
  TSimpleZipThread = class(TThread)
  private
    FDirectory: string;
    FZipFile: string;
  protected
    procedure Execute; override;
  public
    constructor Create(const aDirectory, aZipFile: string; DoOnTerminate: TNotifyEvent );
  end;

implementation

uses
  System.SysUtils, System.Zip;

{
  Wichtig: Methoden und Eigenschaften von Objekten in visuellen Komponenten knnen nur
  in einer Methode verwendet werden, die mit 'Synchronize' aufgerufen wird, z.B.:

      Synchronize(UpdateCaption);

  und UpdateCaption knnte folgendermaen aussehen:

    procedure ddd.UpdateCaption;
    begin
      Form1.Caption := 'Im Thread aktualisiert';
    end;

    oder

    Synchronize(
      procedure
      begin
        Form1.Caption := 'Im Thread ber eine anonyme Methode aktualisiert'
      end
      )
    );

  wobei eine anonyme Methode bergeben wird.

  Entsprechend kann der Entwickler die Methode 'Queue' mit den gleichen Parametern wie oben
  aufrufen, anstatt eine andere TThread-Klasse als ersten Parameter zu bergeben, und
  den aufrufenden Thread in eine Warteschlange mit dem anderen Thread zu stellen.

}

{ TSimpleZipThread }

constructor TSimpleZipThread.Create(const aDirectory, aZipFile: string; DoOnTerminate: TNotifyEvent );
begin
  inherited Create(false);
  FDirectory := aDirectory;
  FZipFile := aZipFile;
  FreeOnTerminate := true;
  OnTerminate := DoOnterminate;
end;


procedure TSimpleZipThread.Execute;
begin
  NameThreadForDebugging(ExtractFileName(FZipFile));
  TZipFile.ZipDirectoryContents(FZipFile, FDirectory);
//   Synchronize(
//      procedure
//      begin
//        FrmZip.Working := false;
//      end
//      )

end ;


end.
